public class TestDriver {
	public static void main(String[] args) {
		if (args.length < 1) {
			System.err.println("Usage:");
			System.err.println("  java TestDriver <sortedListFactoryClassName>");
			System.exit(0);
		}

		DataManager.setDefaultSortedListFactory(args[0]);

		SortedList sortedList = SortedListFactory.getInstance();

		sortedList.insert(new ListItem(5));
		sortedList.insert(new ListItem(2));
		sortedList.insert(new ListItem(6));
		sortedList.insert(new ListItem(8));
		sortedList.insert(new ListItem(1));
		sortedList.insert(new ListItem(7));
		sortedList.insert(new ListItem(4));
		sortedList.insert(new ListItem(3));

		SortedListIterator iterator = sortedList.getIterator();
		System.out.println("List:");
		ListItem current = null;
		while((current = iterator.nextItem()) != null) {
			System.out.println("\t"+current.getValue());
		}
	}
}