public class TreeSortedList implements SortedList {
	private TreeSortedListItem root = null;
	
	public TreeSortedList() {}

	public void insert(ListItem item) {
		TreeSortedListItem newItem = new TreeSortedListItem(item.getValue());
		if (root == null) {
			newItem.parent = null;
			newItem.leftChild = null;
			newItem.rightChild = null;
			root = newItem;
			return;
		}
		TreeSortedListItem current = root;
		while(true) {
			if (current.getValue() == item.getValue()) {
				return; // no duplicates
			} else if (current.getValue() > item.getValue()) {
				if (current.leftChild == null) {
					newItem.parent = current;
					newItem.leftChild = null;
					newItem.rightChild = null;
					current.leftChild = newItem;
					return;
				} else {
					current = current.leftChild;
				}
			} else {
				if (current.rightChild == null) {
					newItem.parent = current;
					newItem.leftChild = null;
					newItem.rightChild = null;
					current.rightChild = newItem;
					return;
				} else {
					current = current.rightChild;
				}
			}
		}
	}

	public SortedListIterator getIterator() {
		return new TreeSortedListIterator(root);
	}
}