import junit.framework.*;

import b.B;

public class BTest extends TestCase {
   // creates a named test
   // testName should be the name of a method
   public BTest(String testName) {
      super(testName);
   }

   // this method creates a suite including all tests available
   public static Test suite() {
      TestSuite suite = new TestSuite();
      suite.addTest(new BTest("testGetMessageNullArgument"));
      suite.addTest(new BTest("testGetMessageNormalArgument"));
      return suite;
   }
   
   // Test Method
   // This method tests that the getMessage method throws an
   // InvalidArgumentException if its name argument is null
   public void testGetMessageNullArgument() {
      B b = new B();
      String result = null;
      try {
	     result = b.getMessage(null);
	     fail("null argument did not generate IllegalArgumentException as expected");
      } catch (IllegalArgumentException e) {
      }
   }

   // Test Method
   // This method tests that the getMessage method returns the
   // correct message given a valid (non-null) argument.
   public void testGetMessageNormalArgument() {
      B b = new B();
      String result = b.getMessage("Bob");
      assertEquals("Hello, Bob!", result);
   }

   // so that these tests can be invoked from the command line   
   public static void main(String[] args) {
      junit.textui.TestRunner.run(suite());
   }
}